PF-build.sh 35 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489490491492493494495496497498499500501502503504505506507508509510511512513514515516517518519520521522523524525526527528529530531532533534535536537538539540541542543544545546547548549550551552553554555556557558559560561562563564565566567568569570571572573574575576577578579580581582583584585586587588589590591592593594595596597598599600601602603604605606607608609610611612613614615616617618619620621622623624625626627628629630631632633634635636637638639640641642643644645646647648649650651652653654655656657658659660661662663664665666667668669670671672673674675676677678679680681682683684685686687688689690691692693694695696697698699700701702703704705706707708709710711712713714715716717718719720721722723724725726727728
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Donnot istall 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machinename> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.0.6-Build_10
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with english only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and english only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selction GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR english only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Splitted the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Ardunio IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env gihub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards github fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modiffied checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers respository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for comming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have seperated build enviroments depening on Arduino IDE version and
  117. # board-versions.
  118. #### Start check if OSTYPE is supported
  119. OS_FOUND=$( command -v uname)
  120. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  121. linux*)
  122. TARGET_OS="linux"
  123. ;;
  124. msys*|cygwin*|mingw*)
  125. # or possible 'bash on windows'
  126. TARGET_OS='windows'
  127. ;;
  128. nt|win*)
  129. TARGET_OS='windows'
  130. ;;
  131. *)
  132. TARGET_OS='unknown'
  133. ;;
  134. esac
  135. # Windows
  136. if [ $TARGET_OS == "windows" ]; then
  137. if [ $(uname -m) == "x86_64" ]; then
  138. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  139. Processor="64"
  140. elif [ $(uname -m) == "i386" ]; then
  141. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  142. Processor="32"
  143. else
  144. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  145. echo "Please refer to the notes of build.sh$(tput sgr0)"
  146. exit 1
  147. fi
  148. # Linux
  149. elif [ $TARGET_OS == "linux" ]; then
  150. if [ $(uname -m) == "x86_64" ]; then
  151. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  152. Processor="64"
  153. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  154. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  155. Processor="32"
  156. else
  157. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  158. echo "Please refer to the notes of build.sh$(tput sgr0)"
  159. exit 1
  160. fi
  161. else
  162. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  163. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  164. echo "Read the notes of build.sh$(tput sgr0)"
  165. exit 1
  166. fi
  167. sleep 2
  168. #### End check if OSTYPE is supported
  169. #### Prepare bash environment and check if wget, zip and other needed things are available
  170. # Check wget
  171. if ! type wget > /dev/null; then
  172. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  173. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  174. exit 2
  175. fi
  176. # Check for zip
  177. if ! type zip > /dev/null; then
  178. if [ $TARGET_OS == "windows" ]; then
  179. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  180. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  181. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  182. echo "Run git Bash under Administrator privilege and"
  183. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  184. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  185. exit 3
  186. elif [ $TARGET_OS == "linux" ]; then
  187. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  188. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  189. exit 3
  190. fi
  191. fi
  192. # Check python ... needed during language build
  193. if ! type python > /dev/null; then
  194. if [ $TARGET_OS == "windows" ]; then
  195. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  196. exit 4
  197. elif [ $TARGET_OS == "linux" ]; then
  198. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  199. echo "As Python 2.x will not be maintained from 2020 please,"
  200. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  201. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  202. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  203. exit 4
  204. fi
  205. fi
  206. #### End prepare bash environment
  207. #### Set build environment
  208. ARDUINO_ENV="1.8.5"
  209. BUILD_ENV="1.0.6"
  210. BOARD="rambo"
  211. BOARD_PACKAGE_NAME="PrusaResearchRambo"
  212. BOARD_VERSION="1.0.1"
  213. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  214. BOARD_FILENAME="prusa3drambo"
  215. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3drambo-1.0.1.tar.bz2"
  216. PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env/releases/download/$BUILD_ENV/PF-build-env-$BUILD_ENV.zip"
  217. LIB="PrusaLibrary"
  218. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  219. # List few useful data
  220. echo
  221. echo "Script path :" $SCRIPT_PATH
  222. echo "OS :" $OS
  223. echo "OS type :" $TARGET_OS
  224. echo ""
  225. echo "Ardunio IDE :" $ARDUINO_ENV
  226. echo "Build env :" $BUILD_ENV
  227. echo "Board :" $BOARD
  228. echo "Package name:" $BOARD_PACKAGE_NAME
  229. echo "Specific Lib:" $LIB
  230. echo ""
  231. #### Start prepare building environment
  232. #Check if build exists and creates it if not
  233. if [ ! -d "../PF-build-dl" ]; then
  234. mkdir ../PF-build-dl || exit 5
  235. fi
  236. cd ../PF-build-dl || exit 6
  237. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  238. # Check if PF-build-env-<version> exists and downloads + creates it if not
  239. # The build environment is based on the supported Arduino IDE portable version with some changes
  240. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  241. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  242. mkdir ../PF-build-env-$BUILD_ENV
  243. sleep 5
  244. fi
  245. # Download and extract supported Arduino IDE depending on OS
  246. # Windows
  247. if [ $TARGET_OS == "windows" ]; then
  248. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  249. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  250. sleep 2
  251. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 7
  252. echo "$(tput sgr 0)"
  253. fi
  254. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  255. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  256. sleep 2
  257. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 7
  258. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  259. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  260. echo "$(tput sgr0)"
  261. fi
  262. fi
  263. # Linux
  264. if [ $TARGET_OS == "linux" ]; then
  265. # 32 or 64 bit version
  266. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  267. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  268. sleep 2
  269. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  270. echo "$(tput sgr 0)"
  271. fi
  272. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  273. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  274. sleep 2
  275. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 8
  276. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  277. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  278. echo "$(tput sgr0)"
  279. fi
  280. fi
  281. # Make Arduino IDE portable
  282. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  283. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  284. fi
  285. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  286. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  287. fi
  288. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  289. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  290. fi
  291. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  292. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  293. fi
  294. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  295. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  296. fi
  297. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  298. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  299. fi
  300. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  301. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  302. fi
  303. # Change Arduino IDE preferences
  304. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  305. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  306. sleep 2
  307. echo "update.check"
  308. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  309. echo "board"
  310. sed -i 's/board = uno/board = $BOARD/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  311. echo "editor.linenumbers"
  312. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  313. echo "boardsmanager.additional.urls"
  314. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  315. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  316. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  317. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  318. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  319. echo "$(tput sgr0)"
  320. fi
  321. # Download and extract Prusa Firmware related parts
  322. # Download and extract PrusaResearchRambo board
  323. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  324. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  325. sleep 2
  326. wget $BOARD_FILE_URL || exit 9
  327. fi
  328. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  329. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  330. sleep 2
  331. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 10
  332. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  333. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  334. fi
  335. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  336. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  337. fi
  338. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  339. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  340. fi
  341. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  342. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  343. fi
  344. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  345. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  346. echo "$(tput sgr 0)"
  347. fi
  348. # Download and extract Prusa Firmware specific library files
  349. if [ ! -f "PF-build-env-$BUILD_ENV.zip" ]; then
  350. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  351. sleep 2
  352. wget $PF_BUILD_FILE_URL || exit 11
  353. echo "$(tput sgr 0)"
  354. fi
  355. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  356. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  357. sleep 2
  358. unzip -o PF-build-env-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 12
  359. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  360. echo "$(tput sgr0)"
  361. fi
  362. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  363. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  364. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  365. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  366. sleep 2
  367. fi
  368. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  369. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  370. sleep 2
  371. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  372. sleep 2
  373. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  374. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  375. echo "$(tput sgr0)"
  376. fi
  377. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  378. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  379. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  380. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  381. sleep 2
  382. echo "$(tput sgr0)"
  383. exit 13
  384. fi
  385. #### End prepare building
  386. #### Start
  387. cd $SCRIPT_PATH
  388. # First argument defines which variant of the Prusa Firmware will be compiled
  389. if [ -z "$1" ] ; then
  390. # Select which variant of the Prusa Firmware will be compiled, like
  391. PS3="Select a variant: "
  392. while IFS= read -r -d $'\0' f; do
  393. options[i++]="$f"
  394. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  395. select opt in "${options[@]}" "All" "Quit"; do
  396. case $opt in
  397. *.h)
  398. VARIANT=$(basename "$opt" ".h")
  399. VARIANTS[i++]="$opt"
  400. break
  401. ;;
  402. "All")
  403. VARIANT="All"
  404. VARIANTS=${options[*]}
  405. break
  406. ;;
  407. "Quit")
  408. echo "You chose to stop"
  409. exit
  410. ;;
  411. *)
  412. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  413. ;;
  414. esac
  415. done
  416. else
  417. if [ -f "$SCRIPT_PATH/Firmware/variants/$1" ] ; then
  418. VARIANTS=$1
  419. else
  420. echo "$(tput setaf 1)$1 could not be found in Firmware/variants please choose a valid one$(tput setaf 2)"
  421. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  422. echo "$(tput sgr0)"
  423. exit 21
  424. fi
  425. fi
  426. #Second argument defines if it is an english only version. Known values EN_ONLY / ALL
  427. #Check default language mode
  428. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  429. if [ -z "$2" ] ; then
  430. PS3="Select a language: "
  431. echo
  432. echo "Which lang-build do you want?"
  433. select yn in "Multi languages" "English only"; do
  434. case $yn in
  435. "Multi languages")
  436. LANGUAGES="ALL"
  437. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  438. break
  439. ;;
  440. "English only")
  441. LANGUAGES="EN_ONLY"
  442. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  443. break
  444. ;;
  445. *)
  446. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  447. ;;
  448. esac
  449. done
  450. else
  451. if [[ "$2" == "ALL" || "$2" == "EN_ONLY" ]] ; then
  452. LANGUAGES=$2
  453. else
  454. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  455. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as 2nd argument!"
  456. exit 22
  457. fi
  458. fi
  459. #Check if DEV_STATUS is selected via argument 3
  460. if [ ! -z "$3" ] ; then
  461. if [[ "$3" == "GOLD" || "$3" == "RC" || "$3" == "BETA" || "$3" == "ALPHA" || "$3" == "DEVEL" || "$3" == "DEBUG" ]] ; then
  462. DEV_STATUS_SELECTED=$3
  463. else
  464. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  465. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL' or 'DEBUG'$(tput sgr0) are allowed as 3rd argument!$(tput sgr0)"
  466. exit 23
  467. fi
  468. fi
  469. #Set BUILD_ENV_PATH
  470. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 24
  471. BUILD_ENV_PATH="$( pwd -P )"
  472. cd ../..
  473. #Checkif BUILD_PATH exists and if not creates it
  474. if [ ! -d "Prusa-Firmware-build" ]; then
  475. mkdir Prusa-Firmware-build || exit 25
  476. fi
  477. #Set the BUILD_PATH for Arduino IDE
  478. cd Prusa-Firmware-build || exit 26
  479. BUILD_PATH="$( pwd -P )"
  480. for v in ${VARIANTS[*]}
  481. do
  482. VARIANT=$(basename "$v" ".h")
  483. # Find firmware version in Configuration.h file and use it to generate the hex filename
  484. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  485. # Find build version in Configuration.h file and use it to generate the hex filename
  486. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  487. # Check if the motherboard is an EINSY and if so only one hex file will generated
  488. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  489. # Check development status
  490. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  491. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  492. if [[ "$DEV_CHECK" == "RC1" || "$DEV_CHECK" == "RC2" ]] ; then
  493. DEV_STATUS="RC"
  494. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  495. DEV_STATUS="ALPHA"
  496. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  497. DEV_STATUS="BETA"
  498. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  499. DEV_STATUS="DEVEL"
  500. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  501. DEV_STATUS="DEBUG"
  502. else
  503. DEV_STATUS="UNKNOWN"
  504. echo
  505. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  506. PS3="Select YES only if source code is tested and trusted: "
  507. select yn in "Yes" "No"; do
  508. case $yn in
  509. Yes)
  510. DEV_STATUS="GOLD"
  511. DEV_STATUS_SELECTED="GOLD"
  512. break
  513. ;;
  514. No)
  515. DEV_STATUS="UNKNOWN"
  516. DEV_STATUS_SELECTED="UNKNOWN"
  517. break
  518. ;;
  519. *)
  520. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  521. ;;
  522. esac
  523. done
  524. fi
  525. else
  526. DEV_STATUS=$DEV_STATUS_SELECTED
  527. fi
  528. #Prepare hex files folders
  529. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  530. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 27
  531. fi
  532. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  533. #Check if exactly the same hexfile already exists
  534. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  535. echo ""
  536. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  537. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  538. read -t 10 -p "Press Enter to continue..."
  539. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  540. echo ""
  541. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  542. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  543. read -t 10 -p "Press Enter to continue..."
  544. fi
  545. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  546. echo ""
  547. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  548. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  549. read -t 10 -p "Press Enter to continue..."
  550. fi
  551. #List some useful data
  552. echo "$(tput setaf 2)$(tput setab 7) "
  553. echo "Variant :" $VARIANT
  554. echo "Firmware :" $FW
  555. echo "Build # :" $BUILD
  556. echo "Dev Check :" $DEV_CHECK
  557. echo "DEV Status :" $DEV_STATUS
  558. echo "Motherboard:" $MOTHERBOARD
  559. echo "Languages :" $LANGUAGES
  560. echo "Hex-file Folder:" $OUTPUT_FOLDER
  561. echo "$(tput sgr0)"
  562. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  563. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  564. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  565. else
  566. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  567. read -t 10 -p "Press Enter to continue..."
  568. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 28
  569. fi
  570. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  571. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  572. # set FW_REPOSITORY
  573. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  574. #Prepare english only or multilanguage version to be build
  575. if [ $LANGUAGES == "ALL" ]; then
  576. echo " "
  577. echo "Multi-language firmware will be built"
  578. echo " "
  579. else
  580. echo " "
  581. echo "English only language firmware will be built"
  582. echo " "
  583. fi
  584. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  585. # if [ $TARGET_OS == "windows" ]; then
  586. # RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  587. # fi
  588. #### End of Prepare building
  589. #### Start building
  590. export ARDUINO=$BUILD_ENV_PATH
  591. #echo $BUILD_ENV_PATH
  592. #export BUILDER=$ARDUINO/arduino-builder
  593. echo
  594. #read -t 5 -p "Press Enter..."
  595. echo
  596. echo "Start to build Prusa Firmware ..."
  597. echo "Using variant $VARIANT$(tput setaf 3)"
  598. sleep 2
  599. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  600. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 14
  601. echo "$(tput sgr 0)"
  602. if [ $LANGUAGES == "ALL" ]; then
  603. echo "$(tput setaf 2)"
  604. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  605. echo "$(tput sgr 0)"
  606. sleep 2
  607. cd $SCRIPT_PATH/lang
  608. echo "$(tput setaf 3)"
  609. ./config.sh || exit 31
  610. echo "$(tput sgr 0)"
  611. # Check if previous languages and firmware build exist and if so clean them up
  612. if [ -f "lang_en.tmp" ]; then
  613. echo ""
  614. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  615. read -t 10 -p "Press Enter to continue..."
  616. echo "$(tput setaf 3)"
  617. ./lang-clean.sh
  618. echo "$(tput sgr 0)"
  619. fi
  620. if [ -f "progmem.out" ]; then
  621. echo ""
  622. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  623. read -t 10 -p "Press Enter to continue..."
  624. echo "$(tput setaf 3)"
  625. ./fw-clean.sh
  626. echo "$(tput sgr 0)"
  627. fi
  628. # build languages
  629. echo "$(tput setaf 3)"
  630. ./lang-build.sh || exit 32
  631. # Combine compiled firmware with languages
  632. ./fw-build.sh || exit 33
  633. echo "$(tput sgr 0)"
  634. # Check if the motherboard is an EINSY and if so only one hex file will generated
  635. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  636. # If the motherboard is an EINSY just copy one hexfile
  637. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  638. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  639. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  640. else
  641. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  642. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  643. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  644. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  645. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  646. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  647. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  648. if [ $TARGET_OS == "windows" ]; then
  649. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  650. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  651. elif [ $TARGET_OS == "linux" ]; then
  652. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  653. fi
  654. fi
  655. # Cleanup after build
  656. echo "$(tput setaf 3)"
  657. ./fw-clean.sh || exit 34
  658. ./lang-clean.sh || exit 35
  659. echo "$(tput sgr 0)"
  660. else
  661. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  662. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 34
  663. fi
  664. # Cleanup Firmware
  665. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 36
  666. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  667. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  668. echo $MULTI_LANGUAGE_CHECK
  669. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  670. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  671. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  672. sleep 5
  673. done
  674. # Switch to hex path and list build files
  675. cd $SCRIPT_PATH
  676. cd ..
  677. echo "$(tput setaf 2) "
  678. echo " "
  679. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  680. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  681. #### End building